include SysInfo.inc
include ../CmnHdr.inc

;**********************CODE SEGMENT*********************************
.code 
start:;START PROG HERE. 
		invoke	GetModuleHandle,NULL
		mov	hInstance,eax
		
		invoke GetVersionEx,addr vi
		.if vi.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS
			mov g_fWin9xIsHost,TRUE
		.endif
		
		invoke	InitCommonControls
		invoke	DialogBoxParam,hInstance,IDD_SYSINFO ,NULL,offset DlgProc,0
		invoke	ExitProcess,NULL

;*************BigNumToString Function********************************
;This function accepts a number and converts it to a string, inserting 
;commas where appropriate.
;********************************************************************
BigNumToString proc lNum:dword,pszBuf:dword
local szNum[100]:byte
local NumberFmt:NUMBERFMT
	invoke wsprintf,addr szNum,SADD("%d"),lNum
	mov NumberFmt.NumDigits,0
	mov NumberFmt.LeadingZero,FALSE
	mov NumberFmt.Grouping,3
	mov NumberFmt.lpDecimalSep,CTXT(".")
	mov NumberFmt.lpThousandSep,CTXT(",")
	mov NumberFmt.NegativeOrder,0
	invoke GetNumberFormat,LOCALE_USER_DEFAULT,0,addr szNum,addr NumberFmt,pszBuf,100
	mov eax, pszBuf
	ret
BigNumToString endp	

;*********************Show CPU Info Function************************
ShowCPUInfo  proc hWnd:HWND,wProcessorArchitecture:word,wProcessorLevel:word,wProcessorRevision:word
	
	dsText szCPUArch,"(Unknown)",55 dup (0)
	dsText szCPULevel,"(Unknown)",55 dup (0)
	dsText szCPURev,"(Unknown)",55 dup (0)
	
	mov ax,wProcessorArchitecture
	movzx eax,ax
	.if eax == PROCESSOR_ARCHITECTURE_INTEL
			invoke lstrcpy,ADDR szCPUArch, SADD("Intel")		
		mov ax,wProcessorLevel
		movzx eax,ax
		.if eax ==3 || eax == 4
			invoke wsprintf,addr szCPULevel, SADD("80%c86"), (wProcessorLevel+"0")
			
			.IF !g_fWin9xIsHost				
				xor ecx,ecx
				xor eax,eax
				mov cx,wProcessorRevision
				mov ax,cx
				movzx cx,cl	
				add ah,'A'			
				movzx ax,ah
				invoke wsprintf,addr szCPURev,SADD("%c%d"),eax,ecx
			.ENDIF
		
		.ELSEIF eax == 5
			invoke wsprintf,ADDR szCPULevel, SADD("Pentium") 
			
			.if !g_fWin9xIsHost			
				xor ecx,ecx
				xor eax,eax
				mov cx,wProcessorRevision
				mov ax,cx
				movzx cx,cl				
				movzx ax,ah
				invoke wsprintf,addr szCPURev, SADD("Model %d, Stepping %d"),eax,ecx			
			.ENDIF
		
		.ELSEIF EAX == 6
			invoke wsprintf,addr szCPULevel,SADD("Pentium Pro or Pentium II")
			
			.if !g_fWin9xIsHost				
				xor ecx,ecx
				xor eax,eax
				mov cx,wProcessorRevision
				mov ax,cx
				movzx cx,cl				
				movzx ax,ah				
				invoke wsprintf,addr szCPURev,SADD("Model %d, Stepping %d"),ch,cl
			.ENDIF
		.endif
	.ELSEIF EAX == PROCESSOR_ARCHITECTURE_ALPHA
		invoke lstrcpy,addr szCPUArch, SADD("Alpha") 
		invoke wsprintf,addr szCPULevel, SADD("%d"), wProcessorLevel
		xor ecx,ecx
		xor eax,eax
		mov cx,wProcessorRevision
		mov ax,cx
		movzx cx,cl	
		add ah,'A'			
		movzx ax,ah		
		invoke wsprintf,addr szCPURev, SADD("Model %c, Pass %d"),ah,al
		
	.ELSEIF EAX == PROCESSOR_ARCHITECTURE_IA64
		invoke lstrcpy,addr szCPUArch, SADD("IA-64")
		invoke wsprintf,addr szCPULevel, SADD("%d"), wProcessorLevel
		xor ecx,ecx
		xor eax,eax
		mov cx,wProcessorRevision
		mov ax,cx
		movzx cx,cl	
		add ah,'A'			
		movzx ax,ah		
		invoke wsprintf,addr szCPURev, SADD("Model %c, Pass %d"),ah,al
		
	.ELSEIF EAX == PROCESSOR_ARCHITECTURE_ALPHA64
		invoke lstrcpy,addr szCPUArch,SADD("Alpha64")
		invoke wsprintf,ADDR szCPULevel,SADD("%d"), wProcessorLevel
		xor ecx,ecx
		xor eax,eax
		mov cx,wProcessorRevision
		mov ax,cx
		movzx cx,cl	
		add ah,'A'			
		movzx ax,ah		
		invoke wsprintf,addr szCPURev,SADD("Model %c, Pass %d"),ah,al
	
	.ELSE
		INVOKE wsprintf,addr szCPUArch, SADD("Unknown")
	.endif
	
	invoke SetDlgItemText,hWnd, IDC_PROCARCH,addr  szCPUArch
	invoke SetDlgItemText,hWnd, IDC_PROCLEVEL,addr szCPULevel
	invoke SetDlgItemText,hWnd, IDC_PROCREV,  addr szCPURev			
 	ret
ShowCPUInfo endp

;***********DIALOG MESSAGE PROCEDURE*****************************
DlgProc	proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
local szBuf[50]:byte

		mov	eax,uMsg
		.if	eax == WM_CLOSE
			invoke	EndDialog,hWnd,NULL
		.elseif	eax == WM_INITDIALOG
			chSETDLGICONS hWnd, IDI_SYSINFO;set dlg icon.
			
			invoke GetSystemInfo,addr sinf
			.if g_fWin9xIsHost
				mov eax,sinf.dwProcessorType 
				mov cx,100
				div cx
				mov sinf.wProcessorLevel,ax
			.endif
			
			invoke ShowCPUInfo,hWnd, sinf.wProcessorArchitecture,sinf.wProcessorLevel, sinf.wProcessorRevision
			
			invoke BigNumToString,sinf.dwPageSize,addr szBuf
			invoke SetDlgItemText,hWnd, IDC_PAGESIZE,eax
						
			invoke dw2hex,sinf.lpMinimumApplicationAddress,addr szBuf
			invoke SetDlgItemText,hWnd, IDC_MINAPPADDR,addr szBuf
						
			invoke dw2hex,sinf.lpMaximumApplicationAddress,addr szBuf
			INVOKE SetDlgItemText,hWnd, IDC_MAXAPPADDR,addr szBuf
			
			invoke wsprintf ,addr szBuf, SADD("%d"),sinf.dwActiveProcessorMask   			
			invoke SetDlgItemText,hWnd, IDC_ACTIVEPROCMASK,ADDR szBuf
   			
   			invoke BigNumToString,sinf.dwNumberOfProcessors,addr szBuf
   			invoke SetDlgItemText,hWnd, IDC_NUMOFPROCS,eax
   			
   			invoke BigNumToString,sinf.dwAllocationGranularity,addr szBuf
			invoke SetDlgItemText,hWnd, IDC_ALLOCGRAN,eax
			
			
		.elseif	eax == WM_COMMAND
			mov	eax,wParam
			and eax,0ffffh
			.if	eax == IDCANCEL
				invoke	EndDialog,hWnd,NULL
			.endif
		.else
			mov	eax,FALSE
			ret
		.endif		   
		mov	eax,TRUE
		ret
		
DlgProc	endp
;********************************************************************

end	start
